package edu.umich.popcup.android;

import java.io.File;
import java.io.IOException;

import android.app.Activity;
import android.content.Intent;
import android.graphics.Bitmap;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.provider.MediaStore;
import android.view.Menu;
import android.view.View;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.LinearLayout;

@SuppressWarnings("unused")
public class PopCup extends Activity {
	
	private LinearLayout mLinearLayout;
	private ImageView mImageView;
	private Uri mImageUri;
	private Bitmap mImageBitmap;
	private Boolean mImageReady = false;
	
	private static final int DEFAULT_CAMERA = 0;
	private static final String TAG = "PopCup";
	
	public static final int TAKE_PICTURE = Menu.FIRST;
	public static final int SEND_PICTURE = Menu.FIRST + 1;
	
	public static final String IMAGE_URI = "image_uri";
	public static final String IMAGE_READY = "image_ready";
	
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {	
	        super.onCreate(savedInstanceState);
	        
	        if (getIntent().getAction().equals(Intent.ACTION_MAIN)) {
		        setContentView(R.layout.cover);
		        
		        try {
					mImageUri = Uri.fromFile(new File(Environment.getExternalStorageDirectory().getCanonicalPath() + "/test.jpg"));
				} catch (IOException e) {
					e.printStackTrace();
				}
				
		        Button captureButton = (Button) findViewById(R.id.cover_take_picture);
		        captureButton.setOnClickListener( new View.OnClickListener() {			
					public void onClick(View v) {
						Intent intent = new Intent("android.media.action.IMAGE_CAPTURE");
						intent.putExtra(MediaStore.EXTRA_OUTPUT, mImageUri);
						startActivityForResult(intent, DEFAULT_CAMERA);
					}
				});
	        }
    }


	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		super.onActivityResult(requestCode, resultCode, data);
		Intent intent = new Intent(this, ImageDashboard.class);
		startActivity(intent);
	}
    
/*    @Override
    public boolean onCreateOptionsMenu(Menu menu){
    	boolean result = super.onCreateOptionsMenu(menu);
 //   	menu.add(0, SEND_PICTURE, 0, R.string.menu_send_picture);
    	menu.add(0, TAKE_PICTURE, 0, R.string.menu_take_picture);
    	return result;
    }
    
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
    	boolean result = super.onOptionsItemSelected(item);
    	Intent intent = null;
    	
    	switch (item.getItemId()) {
    	case SEND_PICTURE:
    		intent = new Intent(this, SendImage.class);
    		intent.putExtra(PopCup.IMAGE_URI, mImageUri);
    		intent.putExtra(PopCup.IMAGE_READY, mImageReady);
    		startActivity(intent);
    		break;
    	case TAKE_PICTURE:
    		intent = new Intent("android.media.action.IMAGE_CAPTURE");
			intent.putExtra(MediaStore.EXTRA_OUTPUT, mImageUri);
			startActivityForResult(intent, DEFAULT_CAMERA);
    		break;
    	}
    	return result;
    }*/
}