package edu.umich.popcup.android;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.OutputStream;
import java.io.StringWriter;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Arrays;

import android.app.Activity;
import android.content.Intent;
import android.net.Uri;
import android.opengl.GLSurfaceView;
import android.os.Bundle;
import android.util.Log;
import android.view.Window;
import android.view.WindowManager;
import android.widget.TextView;
import edu.umich.popcup.util.Image;
import edu.umich.popcup.util.Model3D;
import edu.umich.popcup.util.Ply;

@SuppressWarnings("unused")
public class SendImage extends Activity {
	
	final static String TAG = "UPLOAD_IMAGE";
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        /*TextView tv = new TextView(this);
        //String str = "Hello";
        String str = sendImage();
        if (str == null) {
        	str = "Error: Connection is not successful.";
        }
        tv.setText(str);
        setContentView(tv);*/
        
        this.requestWindowFeature(Window.FEATURE_NO_TITLE); 
        getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN,
            WindowManager.LayoutParams.FLAG_FULLSCREEN);
        
        //ply.readfile(getResources().openRawResource(R.raw.mouse_1));
        Model3D model = sendImage();
        Mesh mesh = new Mesh();
        mesh.setVertices(model.getVertices(0));
        mesh.setIndices(model.getIndices(0));
        mesh.setTexCoords(model.getTexCoords(0));
        mesh.setTexture(model.getTexture(0));
        
        GLSurfaceView view = new GLSurfaceView(this);
        view.setRenderer(new MeshRenderer(mesh));
        setContentView(view);
    }
    
    private Model3D sendImage() {
    	HttpURLConnection conn = null;
    	ObjectOutputStream oos = null;
    	//DataInputStream inStream = null;
    	ObjectInputStream ois = null;
    	
    	//String responseString = null;
    	
    	String urlString = getString(R.string.server_addr);
    	
		Intent intent = getIntent();
		Bundle extras = intent.getExtras();
		Uri imageUri = (Uri)extras.get(PopCup.IMAGE_URI);
		boolean imageReady = extras.getBoolean(PopCup.IMAGE_READY);
		Image image = (Image)extras.get(ImageDashboard.IMAGE_INFO);
		
		/*if (!imageReady) {
			responseString = "Error: Image is not ready";
			return responseString;
		}*/
    	
    	try { 
    		Log.i(TAG, "Sending request");
    		
    		URL url = new URL(urlString);
    		conn = (HttpURLConnection) url.openConnection();
    		conn.setDoOutput(true);
    		conn.setDoInput(true);
    		conn.setRequestMethod("POST");
    		
    		oos = new ObjectOutputStream(conn.getOutputStream());
    		
    		/*InputStream imageStream = new DataInputStream(getResources().openRawResource(R.raw.test_image));
    		BufferedInputStream buffer = new BufferedInputStream(imageStream);
    		int readByte = 0;
    		while((readByte = buffer.read()) != -1) {
    			dos.write(readByte);
    		}*/   		

    		image.setImageStream(new FileInputStream(new File(imageUri.getPath())));
    		oos.writeObject(image);  		
    		oos.flush();
    		oos.close();
    	} catch (MalformedURLException ex)
		{
			Log.e(TAG, "error: " + ex.getMessage(), ex);
		}

		catch (Exception ioe)
		{
			Log.e(TAG, "error: " + ioe.getMessage(), ioe);
		}
		
		Model3D model = null;
		try {
			/*inStream = new DataInputStream ( conn.getInputStream() );
			responseString = inStream.readLine();
			if (responseString == null) {
				responseString = "Error: the response string is null";
			}

			inStream.close();*/
			ois = new ObjectInputStream(conn.getInputStream());
			model = (Model3D)ois.readObject();
			//responseString = "Pose: " + model.getPose() + "\nCategory: " + model.getCategory();
			//responseString += "\n";
			//StringWriter writer = new StringWriter();
			//Ply.writeVertices(model.getVertices(0), writer);
			//writer.write(Arrays.toString(model.getVertices(0)));
			//responseString += writer.toString();
			//Log.i("SEND_IMAGE", dataString);
		}
		catch (Exception ioex){
			Log.e("MediaPlayer", "error: " + ioex.getMessage(), ioex);
		}
		conn.disconnect();
    	
    	
    	return model;
    }
    
	private String testTextTrans() {
    	HttpURLConnection conn = null;
    	DataOutputStream dos = null;
    	DataInputStream inStream = null;
    	
    	String responseString = null;
    	
    	String urlString = getString(R.string.server_addr);
    	
    	try { 
    		Log.i(TAG, "Sending request");
    		URL url = new URL(urlString);
    		conn = (HttpURLConnection) url.openConnection();
    		conn.setDoOutput(true);
    		conn.setDoInput(true);
    		conn.setRequestMethod("POST");
			conn.setRequestProperty("Connection", "Keep-Alive");
    		OutputStream os = conn.getOutputStream();
    		dos = new DataOutputStream(os);
    		dos.flush();
    		dos.close();
    	} catch (MalformedURLException ex)
		{
			Log.e(TAG, "error: " + ex.getMessage(), ex);
		}

		catch (Exception ioe)
		{
			Log.e(TAG, "error: " + ioe.getMessage(), ioe);
		}
		
		try {
			inStream = new DataInputStream ( conn.getInputStream() );
			responseString = inStream.readLine();
			if (responseString == null) {
				responseString = "Error: the response string is null";
			}

			inStream.close();
		}
		catch (Exception ioex){
			Log.e("MediaPlayer", "error: " + ioex.getMessage(), ioex);
		}
		
		conn.disconnect();
    	
		return responseString;
    }
    
    /*private void doFileUpload(String exsistingFileName, String xml){

		HttpURLConnection conn = null;
		DataOutputStream dos = null;
		DataInputStream inStream = null;


		//String exsistingFileName = "/sdcard/img2.jpg"; 
		// Is this the place are you doing something wrong.

		String lineEnd = "\r\n";
		String twoHyphens = "--";
		String boundary =  "-----------------------------29772313742745";


		int bytesRead, bytesAvailable, bufferSize;

		byte[] buffer;

		int maxBufferSize = 1*1024*1024;


		String responseFromServer = "";

		String urlString = Constants.WEB_ADDRESS+"upload.do";


		try
		{
			//------------------ CLIENT REQUEST

			Log.e("MediaPlayer","Inside second Method");

			FileInputStream fileInputStream = new FileInputStream(new File(exsistingFileName) );

			// open a URL connection to the Servlet

			URL url = new URL(urlString);
			// Open a HTTP connection to the URL
			conn = (HttpURLConnection) url.openConnection();
			// Allow Inputs
			conn.setDoInput(true);
			// Allow Outputs
			conn.setDoOutput(true);
			// Don't use a cached copy.
			conn.setUseCaches(false);
			// Use a post method.
			conn.setRequestMethod("POST");
			conn.setRequestProperty("Connection", "Keep-Alive");
			//conn.setRequestProperty("Cookie", "JSESSIONID="+PlayList.getSessionId());
			conn.setRequestProperty("Content-Type", "multipart/form-data;boundary="+boundary);

			dos = new DataOutputStream( conn.getOutputStream() );

			dos.writeBytes(twoHyphens + boundary + lineEnd);
			dos.writeBytes("Content-Disposition: form-data; name=\"xml\""+lineEnd+URLEncoder.encode(xml,"UTF-8") + lineEnd);
			dos.writeBytes(boundary + lineEnd);
			//dos.writeBytes(twoHyphens + boundary + twoHyphens + lineEnd);
			dos.writeBytes("Content-Disposition: form-data; name=\"fileFile\";filename=\"" + exsistingFileName +"\"" + lineEnd);
			dos.writeBytes(lineEnd); 

			Log.e("MediaPlayer","xml ");

			Log.e("MediaPlayer","Headers are written");

			// create a buffer of maximum size

			bytesAvailable = fileInputStream.available();
			bufferSize = Math.min(bytesAvailable, maxBufferSize);
			buffer = new byte[bufferSize];

			// read file and write it into form...

			bytesRead = fileInputStream.read(buffer, 0, bufferSize);

			while (bytesRead > 0)
			{
				dos.write(buffer, 0, bufferSize);
				bytesAvailable = fileInputStream.available();
				bufferSize = Math.min(bytesAvailable, maxBufferSize);
				bytesRead = fileInputStream.read(buffer, 0, bufferSize);
			}

			// send multipart form data necesssary after file data...

			dos.writeBytes(lineEnd);
			dos.writeBytes(twoHyphens + boundary + twoHyphens + lineEnd);

			// close streams
			Log.e("MediaPlayer","File is written");
			fileInputStream.close();
			dos.flush();
			dos.close();


		}
		catch (MalformedURLException ex)
		{
			Log.e("MediaPlayer", "error: " + ex.getMessage(), ex);
		}

		catch (Exception ioe)
		{
			Log.e("MediaPlayer", "error: " + ioe.getMessage(), ioe);
		}


		//------------------ read the SERVER RESPONSE


		try {
			inStream = new DataInputStream ( conn.getInputStream() );
			String str;

			while (( str = inStream.readLine()) != null)
			{
				Log.e("MediaPlayer","Server Response"+str);
			}
			inStream.close();

		}
		catch (Exception ioex){
			Log.e("MediaPlayer", "error: " + ioex.getMessage(), ioex);
		}

	}*/
}